<template>
  <div class="titul">
    <div class="titul__row">
      <div class="titul__title">
        <h2>Название политики</h2>
        <i :class="['icon', 'checked', isTitleValid ? 'is-valid' : '']"></i>
      </div>
      <ob-input 
        v-model="title"
        label="Название политики"
        placeholder="Введите название, чтобы в дальнейшем легче было ориентироваться"
        required
        :disabled="rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED'"
        @input="formChanged('title')"
        data-qa="tms-name"
      />
    </div>

    <div class="titul__row titul__row--small">
      <div class="titul__title">
        <h2>Действие политики распределения</h2>
        <i :class="['icon', 'checked', isTypeValid ? 'is-valid' : '']"></i>
      </div>
      <obSelect
        v-model="type"
        :items="typeItems"
        label="Тип квотирования"
        placeholder="Выберите из списка"
        required
        disabled
        @input="formChanged('type')"
        data-qa="tms-type"
      />
    </div>

    <div class="titul__row titul__row--date">
      <div class="titul__date">
        <orderDatePicker
          v-model="startDate"
          :blockDaysBeforeToday="true"
          label="Дата начала действия"
          required
          :disabled="rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED'"
          @input="formChanged('startDate')"
          data-qa="tms-start-date"
        />
      </div>
      <div class="titul__date">
        <orderDatePicker
          v-model="endDate"
          :blockDaysBeforeToday="true"
          label="Дата окончания действия"
          required
          :disabled="rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED'"
          @input="formChanged('endDate')"
          data-qa="tms-end-date"
        />
      </div>
      <div class="titul__auto-cont">
        <ob-checkbox
          v-model="auto"
          label="Автопродление"
          :disabled="rule.titul.status === 'ACTIVE' || rule.titul.status === 'TERMINATED' || rule.titul.status === 'REMOVED'"
          @change="formChanged('auto')"
          data-qa="tms-auto-renewal"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import ObInput from 'common-components/src/obComponents/obInput';
import ObSelect from 'common-components/src/obComponents/obSelect';
import OrderDatePicker from "common-components/src/obComponents/obDatePickerConstructor";
import ObCheckbox from 'common-components/src/obComponents/obCheckbox';

export default {
  name: 'titulTab',

  components: {
    ObInput,
    ObSelect,
    OrderDatePicker,
    ObCheckbox
  },

  data() {
    return {
      title: '',
      type: 'VOLUME_SHARE',
      startDate: '',
      endDate: '',
      auto: false,
      typeItems: [
        {uuid: 'VOLUME_ON_SUBPERIOD', title: 'Объём на подпериод'},
        {uuid: 'VOLUME', title: 'Объём за весь период'},
        {uuid: 'VOLUME_SHARE', title: 'Процент от объёма'}
      ]
    }
  },

  computed: {
    ...mapGetters({
      rule: 'tms/rule'
    }),
    isTitleValid() {
      return !!this.title.length;
    },

    isTypeValid() {
      return !!this.type.length;
    }
  },

  watch: {
    rule: {
      handler: function(newVal) {
        this.title = newVal.titul.title;
        this.type = newVal.titul.quotationType;
        this.startDate = newVal.titul.applyFromD;
        this.endDate = newVal.titul.applyToD;
        this.auto = newVal.titul.needAutoRenewal;
      },
      immediate: true
    }
  },

  methods: {
    ...mapActions({
      setRuleTitul: 'tms/setRuleTitul'
    }),
    formChanged() {
      this.setRuleTitul({ title: this.title, quotationType: this.type, status: this.rule.titul.status, readyActivate: this.rule.titul.readyActivate, subperiod: this.rule.titul.subperiod, applyFromD: this.startDate, applyToD: this.endDate, needAutoRenewal: this.auto });
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.titul__row {
  margin-bottom: 20px;
  max-width: 680px;

  &--small {
    max-width: 474px;
  }

  &--date {
    display: flex;
    align-items: center;
  }
}

.titul__title {
  width: 100%;
  display: flex;
  align-items: center;
  margin-top: 30px;
  margin-bottom: 7px;

  h2 {
    font-weight: bold;
    font-size: 20px;
    line-height: 28px;
    letter-spacing: 0.4px;
    color: #191e32;
  }

  .icon {
    display: flex;
    margin-left: 6px;
    color: $color-grey-border;

    &.is-valid {
      color: $color-green-light;
    }
  }
}

.titul__date {
  width: 232px;

  &:not(:first-child) {
    margin-left: 10px;
  }
}

.titul__auto-cont {
  margin-left: 25px;
}

</style>